{
  (c)   , -, 2001
      E-Mail:  Dmitry.Plyako@paloma.spbu.ru
      NetMail: 2:5030/922.20
}
unit VCLRoutine;
//       
//   VCL 
interface

uses StdCtrls, ComCtrls, Grids, DBGrids;

type
  SetOfByte = set of byte;

{
  ***  ()   CustomGrid' ***
   SizeColumn  ,     .
       ,       .
  ,       
   OnResize (  ,    ),
    aGrid.ScrollBars  ssVertical (  ssBoth);
  ,    -   
    .
}
procedure ResizeCustomGrid(aGrid: TCustomGrid; SizeColumn: Integer=-1);


{
  ***  ()   DBGrid' ***
   SizeColumn  ,     .
       ,       .
}
procedure ResizeCustomDBGrid(aGrid: TCustomDBGrid; SizeColumn: Integer=-1);


{
  ***   StatusBar'    ***
    DontResize     , 
     
}
procedure ResizeStatusBar(aBar: TStatusBar; const DontResize: SetOfByte=[]);


{
  *** ,       ***
        , 
      .
           ,
     -1.
}
function CanResizeCustomGridColumn(aGrid: TCustomGrid;
                                   const x,y: Integer): Integer;

{
  *** ,       ***
    CanResizeCustomGridColumn  CustomDBGrid
}
function CanResizeCustomDBGridColumn(aGrid: TCustomDBGrid;
                                     const x,y: Integer): Integer;


{
  ***       StringGrid' ***
     Row1  Row2  
}
procedure SwapRows(aGrid: TStringGrid; const Row1, Row2: Integer);


implementation
uses SysUtils, Windows;

type
  //  ,      
  TPublicDBGrid = class(TCustomDBGrid);

  TPublicGrid = class(TCustomGrid);


///////////////////////////////////////////////////////////////////
//                                         //
///////////////////////////////////////////////////////////////////

//      
function CustomGridLineWidth(aGrid: TCustomGrid): Integer;
begin
  with TPublicGrid(aGrid) do
    if [goFixedVertLine, goVertLine]*Options = [] then
         Result := 0
    else Result := GridLineWidth;
end;

//      
function CustomGridLineHeight(aGrid: TCustomGrid): Integer;
begin
  with TPublicGrid(aGrid) do
    if [goFixedHorzLine, goHorzLine]*Options = [] then
         Result := 0
    else Result := GridLineWidth;
end;


{
    ResizeCustom[Db]Grid.  ,
      SizeColumn  Resizing'.
    SizeColumn   (  
    ),   
   .
}
function CalcResizeCustomGrid(aGrid: TCustomGrid; SizeColumn: Integer): Integer;
var i: Integer;            // 
    NewWidth: Integer;     // ,   
    ColIsVisible: Boolean; //    
    LineWidth: Integer;    //   
    ColumnHigh: Integer;   //    
    ColumnCount: Integer;  //     
begin
  with TPublicGrid(aGrid) do
    begin
  //  :
     ColumnCount := ColCount; //     
     if SizeColumn<0 then     //     
        SizeColumn := Pred(ColumnCount);
     NewWidth := ClientWidth; //      ClientWidth
     LineWidth := CustomGridLineWidth(aGrid); //    
  //   NewWidth   
     for i:=0 to Pred(FixedCols) do
        dec(NewWidth, ColWidths[i]);
  //   
     //    (  )  
     ColumnHigh := LeftCol+VisibleColCount;
     if ColumnHigh>=ColumnCount then // __  
          dec(ColumnHigh)
     else //    ,     
          dec(NewWidth, LineWidth); //      
  // ,   (  )  SizeColumn:
     ColIsVisible := (LeftCol<=SizeColumn) and (SizeColumn<=ColumnHigh);
  //    NewWidth    :
     for i:=LeftCol to ColumnHigh do
       if i<>SizeColumn then dec(NewWidth, ColWidths[i]);
  //   NewWidth     
     dec(NewWidth, CustomGridLineWidth(aGrid)*(VisibleColCount+FixedCols));
     //  ...
     if NewWidth<0 then NewWidth := -LineWidth;
  // ,  NewWidth --  ,    SizeColumn,
     if ColIsVisible then //        
        Result := NewWidth
     else Result := -NewWidth
    end;
end;


{
    CanResizeGridColumn. ,  
        :
    DelimiterX     --  __  -
    DelimiterWidth --  -
    MouseX         --   
}
function UserCanResize(const DelimiterX, DelimiterWidth, MouseX: Integer): Boolean;
const DefWidth = 8;
var RightWidth: Integer;
begin
{      CalcAxisState  Grids.pas  
       resizing' 
      :
     -   ,      
         resizing'  DefWidth ,  
          DefWidth;    
            
     -      
       ,        .
       ,   ?
}
  if DefWidth<= DelimiterWidth then
     //    DelimiterWidth
     Result := (DelimiterX-DelimiterWidth <= MouseX) and
               (DelimiterX >= MouseX)
  else
    begin
     //    DefWidth
     RightWidth := DelimiterX + ((DefWidth - DelimiterWidth) shr 1);
     Result := (RightWidth-DefWidth+1 <=MouseX) and
               (RightWidth>=MouseX);
    end;
end;




///////////////////////////////////////////////////////////////////
//          ,   interface'             //
///////////////////////////////////////////////////////////////////

procedure ResizeCustomGrid(aGrid: TCustomGrid; SizeColumn: Integer);
var NewWidth: Integer;
begin
  with TPublicGrid(aGrid) do
   begin
     if SizeColumn<0 then //     
        SizeColumn := Pred(ColCount);
     NewWidth := CalcResizeCustomGrid(aGrid,SizeColumn);
     if NewWidth >=0 then
        ColWidths[SizeColumn] := NewWidth;
   end;
end;


///////////////////////////////////////////////////////////////////


procedure ResizeCustomDBGrid(aGrid: TCustomDBGrid; SizeColumn: Integer);
var RealColumn, NewWidth: Integer;
begin
  with TPublicDBGrid(aGrid) do
   begin
     if SizeColumn<0 then //     
       begin
        SizeColumn := Pred(ColCount);
        if (dgIndicator in Options) then dec(SizeColumn)
       end;
     //      
     if (dgIndicator in Options) then
          RealColumn := SizeColumn+1
     else RealColumn := SizeColumn;
     NewWidth := CalcResizeCustomGrid(aGrid,RealColumn);
     if NewWidth >=0 then
        Columns[SizeColumn].Width:=NewWidth;
   end;
end;


///////////////////////////////////////////////////////////////////


procedure ResizeStatusBar(aBar: TStatusBar; const DontResize: SetOfByte);
var NewCount, NewWidth, ModWidth: Integer;
    i: Byte;
begin
  with aBar do
   begin
     // NewCount --    ""
     // NewWidth --   
     NewCount:=Panels.Count; NewWidth:=Width;
     for i:=0 to Pred(NewCount) do
       if (i in DontResize) then
         begin
          dec(NewCount);
          dec(NewWidth,Panels[i].Width);
         end;
     if NewCount>0 then
       begin
       //  
        ModWidth:=NewWidth mod NewCount; //   
        NewWidth:=NewWidth div NewCount; //   
        for i:=0 to Pred(Panels.Count) do
          if not (i in DontResize) then
            if ModWidth>0 then // ""   
              begin Panels[i].Width := NewWidth+1; dec(ModWidth) end
            else Panels[i].Width := NewWidth;
       end;
   end;
end;


///////////////////////////////////////////////////////////////////


function CanResizeCustomGridColumn(aGrid: TCustomGrid;
                                   const x,y: Integer): Integer;
var i: Integer;               // 
    //     ,  (x,y)
    RightDelimiter:  Integer;
    //      ,  (x,y)
    LeftDelimiter:   Integer;
    DelimiterWidth:  Integer; //    
    DelimiterHeight: Integer; //    
begin
  Result := -1;
  With TPublicGrid(aGrid) do
  //  ,     
    if (goColSizing in Options) then
      begin
       //  DelimiterWidth  DelimiterHeight:
       DelimiterWidth  := CustomGridLineWidth(aGrid);
       DelimiterHeight := CustomGridLineHeight(aGrid);
       //    y-  resize' ;  :
       RightDelimiter := -1;
       for i:=0 to Pred(FixedRows) do
         RightDelimiter := RightDelimiter + RowHeights[i] + DelimiterHeight;
       if (y>=0) and (y<=RightDelimiter) then // y- 
         begin
       //    x-  resize' ;  :
          RightDelimiter := 0;
          //  FixedCols      
          for i:=0 to Pred(FixedCols) do
            RightDelimiter := RightDelimiter + ColWidths[i] + DelimiterWidth;
          //         :
          RightDelimiter := RightDelimiter + ColWidths[LeftCol] + DelimiterWidth;
          LeftDelimiter := RightDelimiter;
          //    ,   (x,y)
          i := LeftCol+1;
          while (i<ColCount) and (x>RightDelimiter) do
            begin
             LeftDelimiter := RightDelimiter;
             //     
             RightDelimiter := LeftDelimiter + ColWidths[i] + DelimiterWidth;
             inc(i);
            end; {end of WHILE statement}
          if RightDelimiter>GridWidth then RightDelimiter := GridWidth+DelimiterWidth;
          // ,   x     :
          if UserCanResize(RightDelimiter, DelimiterWidth, x) then
             Result := i-1
          else if UserCanResize(LeftDelimiter, DelimiterWidth, x) then
             Result := i-2;
         end; {end of "if ` y-  `"}
       // !  .
      end {end of "if (goColSizing in Options)"}
end;


///////////////////////////////////////////////////////////////////


function CanResizeCustomDBGridColumn(aGrid: TCustomDBGrid;
                                     const x,y: Integer): Integer;
begin
  Result := CanResizeCustomGridColumn(aGrid,x,y);
  //   :
  if dgIndicator in TPublicDBGrid(aGrid).Options then
     dec(Result);
end;


///////////////////////////////////////////////////////////////////


procedure SwapRows(aGrid: TStringGrid; const Row1, Row2: Integer);
var i: Integer;
    CurString: String;
    LockResult: Boolean;
begin
  with aGrid do
    begin
      //    
      LockResult := LockWindowUpdate(Handle);
      try
        for i:=0 to Pred(ColCount) do
          begin
           CurString     := Cells[i,Row1];
           Cells[i,Row1] := Cells[i,Row2];
           Cells[i,Row2] := CurString;
          end
      finally
        //    
        if LockResult then LockWindowUpdate(0);
      end;
    end;
end;
end.

