unit fDBMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, DBGrids, ExtCtrls, Db, DBTables;

type
  TMainDBForm = class(TForm)
  //  
    Label1: TLabel;
    Label2: TLabel;
  //     
    DemoTable: TTable;
    DemoSource: TDataSource;
  //    
    MyDBGridPanel: TPanel;
    MyDBGrid: TDBGrid;
  //   
    PanelsSplitter: TSplitter;
  //    
    StandartDBGridPanel: TPanel;
    StandartDBGrid: TDBGrid;
  //       
    CoordPanel: TPanel;
    CoordLabel: TLabel;
    PositionLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure MyDBGridMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DBGridsMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private { Private declarations }
    FResizeColumn: Integer;  //  
    FOriginSize: Integer;    //   
    FResizeSum: Integer;     //      
    FWndOrigin: TWndMethod;  // WindowProc 
    //  WindowProc ,  WM_LBUTTONDOWN
    procedure FGridDownMtd(var Msg: TMessage);
  end;

var
  MainDBForm: TMainDBForm;

implementation {$R *.DFM}
uses VCLRoutine;

procedure TMainDBForm.FormCreate(Sender: TObject);
begin
  //  
  FResizeColumn := -1;
  FResizeSum := 0;
  FOriginSize := 0;
  //  WindowProc
  FWndOrigin := MyDBGrid.WindowProc;
  MyDBGrid.WindowProc := FGridDownMtd;
end;

procedure TMainDBForm.DBGridsMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  //   
  CoordLabel.Caption := Format('(%d, %d)',[x,y]);
end;

procedure TMainDBForm.FormResize(Sender: TObject);
begin
  //   
  ResizeCustomDBGrid(MyDBGrid,0);
end;

//      
{ TDBGrid.OnMouseDown  ,     
  ;    ,   OnMouseDown 
     WindowProc }
procedure TMainDBForm.FGridDownMtd(var Msg: TMessage);
begin
  if MSg.Msg = WM_LBUTTONDOWN then
    begin
     // ,      
     FResizeColumn :=
       CanResizeCustomDBGridColumn(MyDBGrid, Msg.LParamLo, Msg.LParamHi);
     //  -,    
     if FResizeColumn>=0 then
        with MyDBGrid do
         begin
           //    
           FOriginSize := Columns[FResizeColumn].Width;
           FResizeSum := FOriginSize;
           //     , 
           if Columns.Count>FResizeColumn+1 then
              //    
              inc(FResizeSum, Columns[FResizeColumn+1].Width);
         end;
    end;
  //    WindowProc
  FWndOrigin(Msg);
end;

procedure TMainDBForm.MyDBGridMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var NewWidth: Integer;
begin
  //    - , ...
  if FResizeColumn>=0 then
     with Sender as TDBGrid do
      begin
       if FResizeColumn<Columns.Count-1 then
       //     , 
         begin
          // ,       
          NewWidth := FResizeSum-Columns[FResizeColumn].Width;
          //  
          if NewWidth<=0 then //    
               Columns[FResizeColumn].Width := FOriginSize
               // ,    
          else Columns[FResizeColumn+1].Width := NewWidth;
         end;
       //       
       ResizeCustomDBGrid(Sender as TDBGrid,0);
      end;
  //    
  FResizeColumn := -1;
end;

end.
