unit fMain;

interface

uses
  Windows, Messages, SysUtils, Controls, Classes, Forms,
  StdCtrls, Grids, ExtCtrls;

type
  TGridForm = class(TForm)
  //  :
    Label1: TLabel;
    Label2: TLabel;
  //    
    MyGridPanel: TPanel;
    MyGrid: TStringGrid;
  //   
    PanelsSplitter: TSplitter;
  //    
    StandartGridPanel: TPanel;
    StandartGrid: TStringGrid;
  //     
    CoordPanel: TPanel;
    CoordLabel: TLabel;
    PositionLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure GridsMouseMove(Sender: TObject; Shift: TShiftState;
                                X, Y: Integer);
    procedure MyGridMouseUp(Sender: TObject; Button: TMouseButton;
                              Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
  private { Private declarations }
    FResizeColumn: Integer;  //  resize' 
    FOriginSize: Integer;    //   
    FResizeSum: Integer;     //   resize'   
    FWndOrigin: TWndMethod;  // WindowProc  MyGrid
    //  WindowProc  MyGird,  WM_LBUTTONDOWN
    procedure FGridDownMtd(var Msg: TMessage);
  end;

var
  GridForm: TGridForm;

implementation {$R *.DFM}
uses VCLRoutine;

procedure TGridForm.FormCreate(Sender: TObject);
begin
  //  
  FResizeColumn := -1;
  FResizeSum := 0;
  FOriginSize := 0;
  //  WindowProc
  FWndOrigin := MyGrid.WindowProc;
  MyGrid.WindowProc := FGridDownMtd;
end;

//  
procedure TGridForm.FormShow(Sender: TObject);
begin
  {    c 
         }
  MyGrid.SetFocus;
  StandartGrid.SetFocus;
  MyGrid.SetFocus;
end;

procedure TGridForm.GridsMouseMove(Sender: TObject;
                              Shift: TShiftState; X, Y: Integer);
begin
  //   
  CoordLabel.Caption := Format('(%d, %d)',[x,y]);
end;

procedure TGridForm.FormResize(Sender: TObject);
begin
  //   
  ResizeCustomGrid(MyGrid);
end;


//      
{ OnMouseDown  ,     
  ;    ,   OnMouseDown
      WindowProc }
procedure TGridForm.FGridDownMtd(var Msg: TMessage);
begin
  if MSg.Msg = WM_LBUTTONDOWN then
    begin
     // ,      
     FResizeColumn :=
       CanResizeCustomGridColumn(MyGrid, Msg.LParamLo, Msg.LParamHi);
     //  -,     
     if FResizeColumn>=0 then
        with MyGrid do
         begin
           FOriginSize := ColWidths[FResizeColumn];
           FResizeSum := FOriginSize;
           //  risize'   , ...
           if ColCount>FResizeColumn+1 then
              // ...  FResizeSum   () 
              inc(FResizeSum, ColWidths[FResizeColumn+1]);
         end;
    end;
  //    WindowProc
  FWndOrigin(Msg);
end;

//      
procedure TGridForm.MyGridMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var NewWidth: Integer;
begin
  //    - , ...
  if FResizeColumn>=0 then
     with Sender as TStringGrid do
      begin
       if FResizeColumn<ColCount-1 then
       //     , 
         begin
          // ,       
          NewWidth := FResizeSum-ColWidths[FResizeColumn];
          //  
          if NewWidth<=0 then //    
               ColWidths[FResizeColumn] := FOriginSize
               // ,    
          else ColWidths[FResizeColumn+1] := NewWidth;
         end;
       //       
       ResizeCustomGrid(Sender as TStringGrid);
      end;
  //    
  FResizeColumn := -1;
end;

end.
